
import ctypes
import _ctypes
import os
import socketserver
import struct
import random
import socket
import sys
import threading
import time
import signal
import gc

apiostring=None

class Apiary(socketserver.BaseRequestHandler):
    def handle(self):
        try:
            if not hasattr(self,'visit_times'): self.visit_times=1
            else: self.visit_times+=1
            apioapio=struct.unpack("!Q",self.request.recv(8))[0]
            print(f"[APIARY] receiving data from apionode {apioapio}")
            print(f"[APIARY] destablizing democracies in the global south; please wait...")
            apioform=struct.unpack("!Q",self.request.recv(8))[0]
            apiosize=struct.unpack("!Q",self.request.recv(8))[0]
            apiolistlist=_ctypes.PyObj_FromPtr(apioform)
            bee=apiolistlist[0]
            apioform2=struct.unpack("!Q",self.request.recv(8))[0]
            print(f"[APIARY] unpacking apiodata...")
            for i in range(apioform2):
                bee[i]=struct.unpack("!q",self.request.recv(8))[0]
            if self.visit_times >= 2: self.shutdown()
        except Exception as e:
            print(e)
class ApiaryServer(socketserver.ThreadingMixIn,socketserver.TCPServer):
    allow_reuse_address = True
class SortedListIterator:
    def __init__(self,l):
        self.list=l
        self.sortedlist=self.sort()
        self.index=0
    def apionode(self,l,lid,lsize,port):
        signal.signal(signal.SIGSEGV,signal.SIG_IGN)
        aid=random.randint(0,9999999999)
        gc.disable()
        serv=None
        thisport=None
        while 1:
            try:
                thisport=random.randint(30000,50000)
                serv=ApiaryServer(("127.0.0.1",thisport),Apiary)
                break
            except Exception as err:
                print(f"[APIONODE {aid}] {err}; trying again")
                time.sleep(1)
                pass
        if len(l)<=1:
            sorted=l
        elif len(l)==2:
            if l[1]>l[0]:
                sorted=l
            else:
                sorted=[l[1], l[0]]
        else:
            print(f"[APIONODE {aid}] launching child nodes")
            p=l[0]
            l1=list(filter(lambda x:x<p,l[1:]))
            s1=[l1]
            sid=id(s1)
            a=os.fork()
            if a==0:
                self.apionode(l1,sid,0,thisport)
                sys.exit()
            l2=list(filter(lambda x:x>p,l[1:]))
            s2=[l2]
            sid=id(s2)
            b=os.fork()
            if b==0:
                self.apionode(l2,sid,0,thisport)
                sys.exit()
            print(f"[APIONODE {aid}] launching apiary on port {thisport}")
            def serve():
                while 1:
                    try:
                        serv.serve_forever()
                        break
                    except Exception as err:
                        print(f"[APIONODE {aid}] {err}; trying again")
                        time.sleep(1)
                        pass
            threading.Thread(target=serve).start()
            os.waitpid(a,0)
            os.waitpid(b,0)
            gc.enable()
            serv.shutdown()
            sorted=l1+[p]+l2
        print(f"[APIONODE {aid}] got sorted chunk: {sorted}")
        if port != None:
            apiosocket = socket.create_connection(("127.0.0.1",port))
            apiosocket.send(struct.pack("!Q",aid))
            apiosocket.send(struct.pack("!Q",lid))
            apiosocket.send(struct.pack("!Q",lsize))
            apiosocket.send(struct.pack("!Q",len(sorted)))
            for i in sorted:
                apiosocket.send(struct.pack("!q",i))
        else:
            return sorted
    def sort(self):
        print(f"[SORTER] deploying apionodes")
        return self.apionode(self.list,None,None,None)
    def __next__(self):
        if self.index>=len(self.sortedlist):
            raise StopIteration
        i=self.sortedlist[self.index]
        self.index += 1
        return i

class SortedList:
    def __init__(self,l):
        self.list = l
    def __iter__(self):
        return SortedListIterator(self.list)
def entry(l):
    print("welcome to apiosort, a powerful concurrent sorting algorithm implementation")
    return list(SortedList(l))
